Attribute VB_Name = "GTJoy"
'-----------------------------------------------
'  GameTools - WCXeBbN擾W[
'-----------------------------------------------

'API錾
'WCXeBbNp
Declare Function joyGetPosEx Lib "winmm.dll" (ByVal uJoyID As Long, pji As JOYINFOEX) As Long
Declare Function joyGetDevCaps Lib "winmm.dll" Alias "joyGetDevCapsA" (ByVal id As Long, lpCaps As JOYCAPS, ByVal uSize As Long) As Long

'萔
'WCXeBbNx
Public Const Sensitivity = &H3000
'API萔
Public Const JOYERR_BASE = 160
Public Const JOYERR_UNPLUGGED = (JOYERR_BASE + 7)
Public Const MMSYSERR_BASE = 0
Public Const MMSYSERR_ERROR = (MMSYSERR_BASE + 1)
Public Const MMSYSERR_NODRIVER = (MMSYSERR_BASE + 6)
Public Const JOY_RETURNX = &H1&
Public Const JOY_RETURNY = &H2&
Public Const JOY_RETURNBUTTONS = &H80&
Public Const RETURNXYBUT = JOY_RETURNX Or JOY_RETURNY Or JOY_RETURNBUTTONS

'joyGetPosExɓn\
Type JOYINFOEX
        dwSize As Long                 '  size of structure
        dwFlags As Long                 '  flags to indicate what to return
        dwXpos As Long                '  x position
        dwYpos As Long                '  y position
        dwZpos As Long                '  z position
        dwRpos As Long                 '  rudder/4th axis position
        dwUpos As Long                 '  5th axis position
        dwVpos As Long                 '  6th axis position
        dwButtons As Long             '  button states
        dwButtonNumber As Long        '  current button number pressed
        dwPOV As Long                 '  point of view state
        dwReserved1 As Long                 '  reserved for communication between winmm driver
        dwReserved2 As Long                 '  reserved for future expansion
End Type
'joyGetDevCapsɓn\(APIr[A[ɂ̂Win3.1̌ÂȂł(^^;))
'̃oUnicode̊֌Wł܂Ȃ߁AByteϐ̔zɂĂ܂B
Type JOYCAPS
        wMid As Integer
        wPid As Integer
        szPname(31) As Byte
        wXmin As Long
        wXmax As Long
        wYmin As Long
        wYmax As Long
        wZmin As Long
        wZmax As Long
        wNumButtons As Long
        wPeriodMin As Long
        wPeriodMax As Long
        wRmin As Long
        wRmax As Long
        wUmin As Long
        wUmax As Long
        wVmin As Long
        wVmax As Long
        wCaps As Long
        wMaxAxes As Long
        wNumAxes As Long
        wMaxButtons As Long
        szRegKey(31) As Byte
        szOEMVxD(259) As Byte
End Type

Type JoyInfo
LR As Long 'El --1 j[g-0 E-1
UD As Long '㉺l --1 j[g-0 -1
Button(1 To 32) As Long '{^ 0-Ă 1-Ă 2- 3-
JoyErr As Long 'G[l
End Type

Function JoyEnabled() As Long
'WCXeBbN̏ԂԂ
'Ԃl 0-G[
'       1-WCXeBbNڑĂȂ
'       2-hCo
'       ̑-G[ԍ

Dim JIE As JOYINFOEX
Dim temp As Long
JIE.dwSize = LenB(JIE)
JIE.dwFlags = RETURNXYBUT
temp = joyGetPosEx(0, JIE)

If temp = 0 Then
JoyEnabled = 0
ElseIf temp = JOYERR_UNPLUGGED Then
JoyEnabled = 1
ElseIf temp = MMSYSERR_NODRIVER Then
JoyEnabled = 2
Else
JoyEnabled = temp
End If

End Function

Function JoyGetNumButtons() As Long
'WCXeBbÑ{^Ԃ
'G[NƂ-1Ԃ
Dim temp As Long, JC As JOYCAPS

temp = joyGetDevCaps(0, JC, LenB(JC))

If temp > 0 Then
JoyGetNumButtons = -1
Exit Function
End If

JoyGetNumButtons = JC.wNumButtons


End Function

Function JoyState(ByVal MaxButton As Long) As JoyInfo
On Error GoTo syori
'WCXeBbN擾
'MaxButton - f[^Ԃ{^(0-32)

'Õ{^
Static PreBut As Long

Dim JIE As JOYINFOEX, temp As Long, a As Long, b As Long
Dim LR As Long, UD As Long, But As Long
With JIE
.dwSize = LenB(JIE)
.dwFlags = RETURNXYBUT
temp = joyGetPosEx(0, JIE)
End With

With JoyState
If temp <> 0 Then 'G[
.JoyErr = temp
Exit Function
End If

'E
LR = JIE.dwXpos
If LR < Sensitivity Then
.LR = -1
ElseIf LR > &H10000 - Sensitivity Then
.LR = 1
Else
.LR = 0
End If

'㉺
UD = JIE.dwYpos
If UD < Sensitivity Then
.UD = -1
ElseIf UD > &H10000 - Sensitivity Then
.UD = 1
Else
.UD = 0
End If

But = JIE.dwButtons

If MaxButton < 0 Then MaxButton = 0
If MaxButton > 32 Then MaxButton = 32
For temp = 1 To MaxButton
a = (2 ^ (temp - 1)) And But
b = (2 ^ (temp - 1)) And PreBut
If a = 0 And b = 0 Then .Button(temp) = 0 'ςȂ
If a > 0 And b > 0 Then .Button(temp) = 1 'ςȂ
If a = 0 And b > 0 Then .Button(temp) = 2 '
If a > 0 And b = 0 Then .Button(temp) = 3 '
Next

PreBut = But

End With
Exit Function

syori:
JoyState.JoyErr = Err.Number

End Function

